[PATCH] xfstests,btrfs: add wrong compress type regression test

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



A test to check if the oops will happen when the users write some
data into the files whose compress flag is set but the compression
of the fs is disabled.

Signed-off-by: Miao Xie <miaox@xxxxxxxxxxxxxx>
---
 tests/btrfs/022     | 82 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/022.out |  5 ++++
 tests/btrfs/group   |  1 +
 3 files changed, 88 insertions(+)
 create mode 100755 tests/btrfs/022
 create mode 100644 tests/btrfs/022.out

diff --git a/tests/btrfs/022 b/tests/btrfs/022
new file mode 100755
index 0000000..0755fb5
--- /dev/null
+++ b/tests/btrfs/022
@@ -0,0 +1,82 @@
+#! /bin/bash
+# FS QA Test No. btrfs/008
+#
+# btrfs wrong compression type regression test, from a user report on
+# linux-btrfs.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Fujitsu.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+
+status=1	# failure is the default!
+
+_cleanup()
+{
+	rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+__workout()
+{
+	work_file="$SCRATCH_MNT/tmpfile"
+
+	touch $work_file || _fail "failed create test file"
+	chattr =c $work_file || _fail "failed change attribute of test file"
+	dd if=/dev/zero of=$work_file bs=1M count=1 oflag=sync &> /dev/null
+	if [ $? -ne 0 ]; then
+		_fail "failed write data into the test file"
+	fi
+}
+
+echo "*** test nodatacow"
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount "-o nodatacow"
+__workout
+_scratch_unmount
+
+echo "*** test compress=no"
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount "-o compress=no"
+__workout
+_scratch_unmount
+
+echo "*** test compress-force=no"
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount "-o compress-force=no"
+__workout
+_scratch_unmount
+
+echo "*** done"
+status=0 ; exit
diff --git a/tests/btrfs/022.out b/tests/btrfs/022.out
new file mode 100644
index 0000000..611fd67
--- /dev/null
+++ b/tests/btrfs/022.out
@@ -0,0 +1,5 @@
+QA output created by 022
+*** test nodatacow
+*** test compress=no
+*** test compress-force=no
+*** done
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 410f8ed..c2adb2f 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -24,3 +24,4 @@
 019 auto quick
 020 auto quick
 021 auto quick
+022 auto quick
-- 
1.8.3.1

_______________________________________________
xfs mailing list
xfs@xxxxxxxxxxx
http://oss.sgi.com/mailman/listinfo/xfs




[Index of Archives]     [Linux XFS Devel]     [Linux Filesystem Development]     [Filesystem Testing]     [Linux USB Devel]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]

  Powered by Linux